<?
// should make the session start

class App {
    private $appName;
    private $version;

    private IHttpMiddleware $middlewarePipeline;

    private DiContainer $container;

    public function __construct($appName, $version, $diContainer) {
        $this->appName = $appName;
        $this->version = $version;
        $this->$diContainer = $diContainer;
    }
    public function use(IHttpMiddleware $middleware) {
        if ($this->middlewarePipeline === null) {
            $this->middlewarePipeline = $middleware;
        } else {
            // Chain the new middleware to the end of the existing pipeline
            $currentMiddleware = $this->middlewarePipeline;
            while ($currentMiddleware->getNext() !== null) {
                $currentMiddleware = $currentMiddleware->getNext();
            }
            $currentMiddleware->setNext($middleware);
        }
    }

    public function getAppName() {
        return $this->appName;
    }

    public function getVersion() {
        return $this->version;
    }

    public function run() {
        echo "Running {$this->appName} version {$this->version}\n";
    }

    // public function run(HttpRequest $request) {
    //     if ($this->middlewarePipeline === null) {
    //         // No middleware defined, return the request as-is
    //         return $request;
    //     }

    //     // Exécutez le middleware en utilisant le pipeline
    //     return $this->middlewarePipeline->handle($request, function($request) {
    //         // Logique de gestion principale de la requête ici
    //         echo "Main Request Handling Logic.\n";
    //         return $request;
    //     });
    // }
    

    // should not be hese responsibibilty add in DI
    public function autoAddMiddlewares() {
        $middlewareClasses = $this->findMiddlewareClasses();

        foreach ($middlewareClasses as $middlewareClass) {
            $this->use(new $middlewareClass());
        }
    }

    // Méthode pour rechercher automatiquement les classes de middleware en utilisant la réflexion
    // private function findMiddlewareClasses() {
    //     $middlewareClasses = [];

    //     // Utilisez la réflexion pour obtenir toutes les classes disponibles
    //     $classes = get_declared_classes();

    //     foreach ($classes as $class) {
    //         $reflectionClass = new ReflectionClass($class);
    //         if ($reflectionClass->implementsInterface(MiddlewareInterface::class)) {
    //             // La classe implémente MiddlewareInterface, ajoutez-la à la liste
    //             $middlewareClasses[] = $class;
    //         }
    //     }

    //     return $middlewareClasses;
    // }
}

?>