<!-- Correspondance des URLs : Le rôle principal du router est de faire correspondre les URLs entrantes aux contrôleurs et aux actions qui doivent les gérer.
Il examine l'URL demandée par le client (par exemple, "/contact") et détermine quelle route correspondante peut être utilisée.

Ces règles peuvent être définies à l'aide d'annotations dans les contrôleurs.

Gestion des paramètres d'URL : Le router extrait également les paramètres d'URL de l'URL demandée. Par exemple, si l'URL est "/articles/123", le router extraira l'identifiant "123" en tant que paramètre pour être transmis au contrôleur.

Gestion des noms de route : Le router attribue des noms aux routes définies, ce qui permet aux développeurs de générer des URLs à partir de noms de route dans leurs vues ou leurs contrôleurs. Cela simplifie la génération d'URLs dans l'application.

Gestion des erreurs de routage : En cas de route non trouvée (par exemple, lorsque l'URL demandée ne correspond à aucune route définie), le router peut générer une réponse HTTP appropriée, généralement une réponse "404 Not Found".

Configuration du contexte de routage : Le router tient compte du contexte de la requête actuelle, ce qui signifie qu'il peut adapter la recherche de routes en fonction des paramètres de la requête, tels que la langue, la méthode HTTP, etc. -->
<!-- 
match: Méthode pour faire correspondre une URL à une route et renvoyer les informations de route.
generate: Méthode pour générer une URL à partir du nom de la route et des paramètres.
getContext: Récupère le contexte de la requête.
setContext: Définit le contexte de la requête.
getRouteCollection: Récupère la collection de routes.
getMatcher: Récupère l'objet UrlMatcher utilisé pour la correspondance des URLs -->

<!-- Création de l'objet Request : Le contrôleur frontal crée un objet Request à partir de la requête HTTP entrante en utilisant la classe Symfony\Component\HttpFoundation\Request.
Configuration du router : Il configure et utilise le router (objet Router) pour faire correspondre l'URL à une route.
Résolution du contrôleur : Le contrôleur frontal résout le contrôleur en utilisant le contrôleur résolveur (généralement une instance de Symfony\Component\HttpKernel\Controller\ControllerResolver).
Exécution de l'action : Il appelle l'action du contrôleur en fonction de la route correspondante et exécute l'action spécifique à la page.
Création de la réponse : Le contrôleur frontal crée un objet Response pour contenir la réponse HTTP générée par l'action du contrôleur.
Envoi de la réponse : Il envoie finalement la réponse HTTP au client en utilisant la méthode send de l'objet Response -->

<?php

// Just a url matcher 

class Router {

    private string $path;
    
    // routes collection
    private AltoRouter $routes;
    
    // public static $verbs = ['GET', 'HEAD', 'POST', 'PUT', 'PATCH', 'DELETE', 'OPTIONS'];

    public function __construct(string $path = "/PHP/project/index.php") {
        $this->path = $path;
        $this->routes = new AltoRouter($this->$path);
    }

    public function add(Route $route, $name) {}

    // extrait également les paramètres d'URL de l'URL demandée

    public function extractParams(string $path) {}

    public function get(string $path, callable $callable, $name) {
        $this->router->map('GET', $path, $callable, $name);
    }

    public function post(string $path, callable $callable, $name) {
        $this->router->map('POST', $path, $callable, $name);
    }
    public function put(string $path, callable $callable, $name) {
        $this->router->map('PUT', $path, $callable, $name);
    }

    public function match (IRequest $request): ?Route {
        $result = $this->routes->match($request->getRequestUri(), $request->getMethod());
        if ($result) {
            return new Route($result['params'],$result['target'],$result['name']) ;
        }
        return null;
    }

    public function 


}


?>